<template>

    <q-page class="bg-base">
        <DocumentWrapper ref="wrap">
            <Container :max-height="1" class="full-width column ">

                <FloorChart ref='Chart' v-if="Opts != null" class="col q-pa-sm" style="box-sizing: border-box"
                            :settings="GraphSettings.StoreValue"
                            :options="Opts"
                            :days="days"/>
                <q-skeleton v-else type="rect" class="full-width col"/>
                <q-separator/>
                <div class="row justify-evenly q-pa-sm">
                    <q-btn flat @click="dialog = true">Change Graph</q-btn>
                    <q-btn flat color="primary" @click="CreateWidget">Add Widget</q-btn>
                </div>
            </Container>
        </DocumentWrapper>
        <q-dialog persistent v-model="createDialog">
            <div class="bg-base q-pa-lg">
                <AddWidgetDialog @create="AddWidget" @back="createDialog = false"/>
            </div>
        </q-dialog>
        <q-dialog persistent v-model="dialog" position="bottom" style="max-width: 800px; width: 100%">
            <div class="bg-base q-pa-lg full-width q-gutter-y-lg">
                <div class="row justify-between">
                    <q-btn primary icon="clear" color="primary" @click="dialog = false" label="close"/>
                </div>
                <q-select
                    :options="floors"
                    emit-value
                    option-value="id"
                    option-label="name"
                    filled
                    map-options
                    label-slot
                    v-model="floorId"
                    @input="FloorChange"
                >
                    <template v-slot:label>
                        <LabelSlot icon="layers" label="Floor"
                                   tooltip="Choose the floor for the analytics"/>
                    </template>
                </q-select>
                <FloorChartOptionsWidget v-model='options' v-if="floorId != null" :days="days"/>
                <TimeQueryPicker v-if="floorId != null" :all="false" v-model="time"/>
            </div>
        </q-dialog>
    </q-page>
</template>

<script lang='ts'>
import {Component, Vue} from 'vue-property-decorator';
import Container from "components/Core/Container.vue";
import FloorChart from "components/Charts/FloorChart.vue";
import FloorChartOptionsWidget, {FloorChartOptionsWidgetInterface} from "components/Charts/FloorChartOptionsWidget.vue";
import {FloorPrincipalResponse} from "src/classLibrary/APIModels/core/floorPrincipalResponse";
import TimeQueryPicker from "pages/Widget/TimeQueryPicker.vue";
import {ChartWidget, RelativeTimeConfig, Widget, WidgetData} from "src/classLibrary/Dashboard/Dashboard";
import LabelSlot from "components/LabelSlot.vue";
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import {format} from "date-fns";
import {FloorGraphOption, GraphScope} from "src/classLibrary/Charting/FloorChart";
import {ToStartEnd} from "src/classLibrary/Dashboard/DashboardUtility";
import AddWidgetDialog from "components/Dialog/AddWidgetDialog.vue";
import {DeepClone, WarnMessage} from "src/classLibrary/Utility";
import {uid} from "quasar";
import {FloorChartWidget} from "src/classLibrary/Dashboard/FloorChartWidget";
import {IWidgetStore, ServerWidgetStore} from "src/classLibrary/Dashboard/WidgetStore";

@Component({
    components: {
        AddWidgetDialog,
        DocumentWrapper, LabelSlot, TimeQueryPicker, FloorChartOptionsWidget, FloorChart, Container
    }
})
export default class FloorChartType extends Vue {
    floorId: string | null = null;
    dialog = false;
    createDialog = false;
    time: RelativeTimeConfig = {
        start: 0,
        amount: 1,
    }
    floors: FloorPrincipalResponse[] = [];
    days: string[] = [];
    options: FloorChartOptionsWidgetInterface = {
        type: 'horizontalBar',
        independent: 'sub',
        valueType: 'value',
        merge: false,
        trades: [],
        scope: GraphScope.Hour(),
    }
    widgetStore: IWidgetStore = new ServerWidgetStore(this.$coreApi, this.$auth, this.PersistentStore.StoreValue.project);

    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    get Opts(): FloorGraphOption | null {

        if (this.floorId == null) return null;
        const [startTime, endTime] = ToStartEnd(this.time, new Date());
        const projectId = this.PersistentStore.StoreValue.project;
        let r: FloorGraphOption = {
            startTime,
            endTime,
            floorId: this.floorId,
            independent: this.options.independent,
            merge: this.options.merge,
            projectId,
            trades: this.options.trades,
            scope: this.options.scope,
            type: this.options.type,
            valueType: this.options.valueType,
        }
        return r;
    }

    async AddWidget(name: string) {

        if (this.Opts == null) return;
        const id = uid();
        const w: FloorChartWidget = {
            setting: DeepClone(this.GraphSettings.StoreValue),
            time: this.time,
            options: this.Opts
        }
        const cw = ChartWidget.Floor(w);
        const data = WidgetData.Chart(cw);
        const widget: Widget = {
            name,
            id,
            widget: data
        }
        const r = await this.widgetStore.AddWidget(widget);
        if (r.isSome()) {
            this.Wrap.SubmitError(r.unwrap())
            return;
        } else {
            await this.$router.push(`/?add=${id}`);
        }
    }


    CreateWidget() {
        if (this.floorId != null) {
            this.createDialog = true;
        } else {
            this.$q.notify(WarnMessage('please select a floor'))
        }
    }

    async FloorChange() {
        if (this.floorId == null) return;
        const token = await this.$auth.AnalyticsToken;
        const pid = this.PersistentStore.StoreValue.project;
        const dayR = await this.$analyticsApi.Get<string[]>(`Analytics/${pid}/${this.floorId}/days`, null, token);
        if (dayR.isOk()) {
            this.Store.StoreValue.filter = 'graph';
            this.Store.StoreValue.rightIcon = 'tune';
            this.days = dayR.unwrap().Map(x => format(new Date(x), "yyyy/MM/dd"));
        }
    }

    async destroyed() {
        this.Store.StoreValue.filter = '';
        this.Store.StoreValue.rightIcon = '';
    }

    async created() {
        await this.loadFloors();
        this.Store.StoreValue.filter = 'graph';
        this.Store.StoreValue.rightIcon = 'tune';
    }

    async loadFloors() {
        const p = this;
        const t = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<FloorPrincipalResponse[]>(`Floor?projectId=${this.PersistentStore.StoreValue.project}`, null, t);

        r.match({
            err: (e) => (p.$refs.wrap as any).SubmitError(e),
            ok: (o) => {
                p.floors = o;
            }
        })

    }

}
</script>

<style lang='scss' scoped>

</style>
